﻿using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;

using Pac.Resources;

namespace Pac.Scene
{
    public class CreditScene : BaseScene
    {
        private static CreditScene instance;

        private BaseScene prevScene;

        public static CreditScene getInstance(BaseScene prev)
        {
            if (instance == null)
            {
                instance = new CreditScene();
            }
            instance.prevScene = prev;
            return instance;
        }

        private CreditScene()
        {
        }

        public override BaseScene Update(GameTime gameTime)
        {
            keyboardState = Keyboard.GetState();

            if (keyboardState.IsKeyDown(Keys.Escape))
            {
                return prevScene;
            }

            return this;
        }

        public override void Draw(GameTime gameTime, SpriteBatch spriteBatch)
        {
            spriteBatch.Begin(SpriteBlendMode.AlphaBlend);
            spriteBatch.Draw(GameTexture.levelBackgroundSprite, new Rectangle(toX(0), toY(0), toX(800), toY(600)), Color.White);

            spriteBatch.Draw(GameTexture.creditsSprite, new Rectangle(toX(0), toY(0), toX(800), toY(600)), Color.White);

            spriteBatch.End();
        }
    }
}
