﻿using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;

using Pac.Resources;

namespace Pac.Scene
{
    public class InstructionScene : BaseScene
    {
        private static InstructionScene instance;

        private BaseScene prevScene;

        public static InstructionScene getInstance(BaseScene prev)
        {
            if (instance == null)
            {
                instance = new InstructionScene();
            }
            instance.prevScene = prev;
            return instance;
        }

        private InstructionScene()
        {
        }

        public override BaseScene Update(GameTime gameTime)
        {
            keyboardState = Keyboard.GetState();

            if (keyboardState.IsKeyDown(Keys.Escape))
            {
                return prevScene;
            }
            if(keyboardState.IsKeyDown(Keys.Space))
            {
                return prevScene;
            }

            return this;
        }

        public override void Draw(GameTime gameTime, SpriteBatch spriteBatch)
        {
            spriteBatch.Begin(SpriteBlendMode.AlphaBlend);
            spriteBatch.Draw(GameTexture.levelBackgroundSprite, new Rectangle(toX(0), toY(0), toX(800), toY(600)), Color.White);

            spriteBatch.Draw(GameTexture.instructionSprite, new Rectangle(toX(0), toY(0), toX(800), toY(600)), Color.White);

            spriteBatch.DrawString(GameTexture.spriteFont, "Press Space to Go back...", new Vector2(toX(350),toY(550)), Color.Yellow);

            spriteBatch.End();
        }
    }
}
