﻿using System.Threading;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;

using Pac.Constants;
using Pac.Index;
using Pac.Resources;

namespace Pac.Scene
{
    public class InitThread
    {
        public void init()
        {
            GameConstants.initMap();
            PathIndexer.startIndexing();
        }
    }

    public class LoadingScene : BaseScene
    {
        public static bool flag = false;
        Thread oThread;
        float timeup = 0;
        bool show = false;

        private static LoadingScene instance = null;

        private LoadingScene() { }

        public static LoadingScene getInstance()
        {
            if (instance == null)
                instance = new LoadingScene();
            return instance;
        }

        public override BaseScene Update(GameTime gameTime)
        {
            keyboardState = Keyboard.GetState();
            if (!flag)
            {
                oThread = new Thread(new ThreadStart(new InitThread().init));
                oThread.Start();
                flag = true;
                while(!oThread.IsAlive);
            }
            if(!oThread.IsAlive)
            {
                if (keyboardState.IsKeyDown(Keys.Space))
                {
                    GameConstants.isIndexed = true;
                    GameConstants.initMap();
                    PacmanScene.getInstance().initialize(1);
                    return PacmanScene.getInstance();
                }
            }
            return this;
        }

        public override void Draw(GameTime gameTime, SpriteBatch spriteBatch)
        {
            timeup += (float)gameTime.ElapsedGameTime.TotalSeconds;
            spriteBatch.Begin(SpriteBlendMode.AlphaBlend);
            spriteBatch.Draw(GameTexture.levelBackgroundSprite, new Rectangle(toX(0), toY(0), toX(800), toY(600)), Color.White);
            spriteBatch.Draw(GameTexture.startScreenSprite, new Rectangle(toX(250), toY(150), toX(300), toY(300)), Color.White);
            if (timeup > 0.5f)
            {
                timeup = 0;
                show = show?false:true;
            }
            if (show)
            {
                if (oThread != null && oThread.IsAlive)
                {
                    spriteBatch.DrawString(GameTexture.spriteFont, "Loading...", new Vector2(toX(370), toY(500)), Color.Yellow);
                }
                else
                {
                    spriteBatch.DrawString(GameTexture.spriteFont, "Press Space to start...", new Vector2(toX(350), toY(500)), Color.Yellow);
                }
            }
            spriteBatch.End();   
        }

    }
}
